from netgen.geom2d import unit_square
from netgen.geom2d import SplineGeometry
from netgen.read_gmsh import ReadGmsh
from ngsolve import *
import numpy as np

def SolveBVP_bl_dg():
    mesh = Mesh(unit_square.GenerateMesh(maxh=0.3))

    order = 2
    fes = L2(mesh, order=order, dgjumps=True)
    u,v = fes.TnT()
    # f = 
    jump_u = u-u.Other()
    jump_v = v-v.Other()
    n = specialcf.normal(2)
    mean_dudn = 0.5*n * (grad(u)+grad(u.Other()))
    mean_dvdn = 0.5*n * (grad(v)+grad(v.Other()))

    alpha = 8

    # Computing the boundary conditions
    theta_0 = np.pi/2.0
    tol = 1e-20
    theta = atan((y+tol)/(x))
    alp = 2.0/3.0
    r = sqrt(x*x+y*y)**alp
    uin = r * sin(alp*(theta+theta_0))

    h = specialcf.mesh_size
    acd = BilinearForm(fes)
    acd += SymbolicBFI((grad(u)*grad(v)))
    acd += SymbolicBFI((alpha*order**2/h*jump_u*jump_v), skeleton=True)
    acd += SymbolicBFI((alpha*order**2/h*uin*v), BND, skeleton=True)
    acd += SymbolicBFI((-mean_dudn*jump_v -mean_dvdn*jump_u), skeleton=True)
    acd += SymbolicBFI((-n*grad(v)*uin), BND, skeleton=True)

    acd.Assemble()
    f = LinearForm(fes)
    f += SymbolicLFI(0.0*v)
    f.Assemble()
    fes.Update()
    acd.Assemble()
    f.Assemble()

    gfu = GridFunction(fes)
    gfu.vec.data = acd.mat.Inverse(freedofs=fes.FreeDofs(),inverse="umfpack") * f.vec
    exact = uin

    err = (gfu-exact)*(gfu-exact)
    l2_err = sqrt(Integrate (err, mesh))
    print(l2_err)
SolveBVP_bl_dg()
